package gravite;

import java.awt.*;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.applet.*;


public class Gravite extends Applet implements Runnable, ItemListener {

protected Thread tr;
protected Image img;
protected Graphics g;
protected GraphCanvas graphC;
protected double t = 0;
protected boolean croissant = true;
protected double x,y;
protected Image soleil = Toolkit.getDefaultToolkit().getImage(Gravite.class.getResource("soleil.gif"));
protected Image jupiter = Toolkit.getDefaultToolkit().getImage(Gravite.class.getResource("jupiter.gif"));
protected Image bal1 = Toolkit.getDefaultToolkit().getImage(Gravite.class.getResource("balance1.gif"));
protected Image bal4 = Toolkit.getDefaultToolkit().getImage(Gravite.class.getResource("balance4.gif"));
protected Image bal1000 = Toolkit.getDefaultToolkit().getImage(Gravite.class.getResource("balance1000.gif"));  
protected CheckboxGroup groupeACocher = new CheckboxGroup();
protected Checkbox select1, select4, select1000;
protected Color grisClair = new Color(80,80,80);

  
public void init() {
	chargementImage();
	setBackground(new Color(123, 125, 173));
	Panel mainPanel = new Panel(new BorderLayout());
  	// Graph
	Panel graphPanel = new Panel();
  	img = createImage(295, 235);
    g = img.getGraphics();
    g.setFont(new Font(getFont().getName(), 1, 10)); 
  	graphC = new GraphCanvas(295, 235);
    graphPanel.add(graphC);
    // Selection
    Panel selectPanel = new Panel(new GridBagLayout());
    GridBagConstraints c = new GridBagConstraints();
    c.weightx = 3.0;
    c.gridx = 0;
    c.gridy = 0;
    c.gridwidth = GridBagConstraints.REMAINDER;
    Label text = new Label(" " + Messages.get("choisir"));
    text.setForeground(Color.white);
    selectPanel.add(text, c);
    c.weightx = 1.0;
    c.gridy = 1;
    c.fill = GridBagConstraints.CENTER;
    c.gridwidth = GridBagConstraints.BOTH;
    select1 = new Checkbox(Messages.get("1_sur_1"),groupeACocher,true);
    select1.setForeground(Color.white);
    select1.addItemListener(this);
    selectPanel.add(select1, c);
    c.gridx = 1;
    select4 = new Checkbox(Messages.get("1_sur_4"),groupeACocher,false);
    select4.setForeground(Color.white);
    select4.addItemListener(this);
    selectPanel.add(select4, c);
    c.gridx = 2;
    c.gridwidth = GridBagConstraints.REMAINDER;
    select1000 = new Checkbox(Messages.get("1_sur_1000"),groupeACocher,false);
    select1000.setForeground(Color.white);
    select1000.addItemListener(this);
    selectPanel.add(select1000, c);
    mainPanel.add(graphPanel, BorderLayout.NORTH);
    mainPanel.add(selectPanel, BorderLayout.SOUTH);
    add(mainPanel);
    go();
}


public void chargementImage() {
    MediaTracker tracker = new MediaTracker(this);
    tracker.addImage(soleil, 0);
    tracker.addImage(jupiter, 1);
    tracker.addImage(bal1, 2);
    tracker.addImage(bal4, 3);
    tracker.addImage(bal1000, 4);
    try { tracker.waitForAll(); }   
    catch (InterruptedException e) { }	
}


public void go() {
    if (tr == null) {
    	tr = new Thread(this);
    	tr.start();
    }
}


public void run() {
    while (true) 
    {
    	if (g!=null) { majGraph(); }
        try { 
        	if (t>113 || t<-113) Thread.sleep(25);
      	    else Thread.sleep(8);
        } 
        catch(InterruptedException e){ }
    }
}


public void itemStateChanged(ItemEvent itemevent) {
    majGraph(); 
    validate();
}
  
  
public void majGraph() {
	if (t>=120) croissant = false;
  	if (t<=-120) croissant = true;
  	if (croissant) t+=0.5; 
  	else  t-=0.5;
  	x = t;
  	y = 0.2 * Math.sqrt(Math.pow(120,2) - Math.pow(x,2));
  	if (croissant) y=-y;
    g.setColor(Color.black);
    g.fillRect(0, 0, 295, 235);  
    g.setColor(new Color(181,191,219));
    g.fillRect(2, 133, 291, 100);
    // rapport 1 sur 1
    if (select1.getState()) {
		g.setColor(grisClair);
    	g.drawOval(27,47,240,47);   
    	g.setColor(Color.lightGray);
    	g.drawString(Messages.get("si_masses_egales"), 4, 12);
    	g.drawString(Messages.get("distance_du_centre_de_gravite") , 4, 24);
    	g.drawString(Messages.get("centre_de_gravite") , 105, 127);
    	g.drawLine(145,71,149,71);
    	for (int i=69; i<112; i=i+6) {
    		g.drawLine(147,i,147,i+4);
    	}
    	g.setColor(Color.black);
    	g.drawString(Messages.get("masses_egales") , 32, 228);
    	g.drawString(Messages.get("distances_egales") , 190, 228);
    	g.drawImage(bal1, 10 , 135, this);
		g.drawImage(bal1, 170 , 135, this);
		g.setColor(Color.white);
  		g.fillOval(-(int)x+137,60-(int)y, 20,20);
  		g.fillOval(15,182, 13,13);
  		g.fillOval(175,182, 13,13);
  		g.setColor(Color.red);
  		g.fillOval((int)x+137,60+(int)y, 20,20);
  		g.fillOval(110,182, 13,13);
  		g.fillOval(270,182, 13,13);
    }
    // rapport 1 sur 4    
    if (select4.getState()) {
		g.setColor(grisClair);
    	g.drawOval(27,47,240,47);   	
    	g.drawOval(117,65,60,12);
    	g.setColor(Color.lightGray);
    	g.drawString(Messages.get("si_masses_differentes_1") , 4, 12);
    	g.drawString(Messages.get("si_masses_differentes_2") , 4, 24);
    	g.drawString(Messages.get("si_masses_differentes_3") , 4, 36);
    	g.drawString(Messages.get("centre_de_gravite") , 105, 127);
    	g.drawLine(145,71,149,71);
    	for (int i = 69; i<112; i=i+6) {
    		g.drawLine(147,i,147,i+4);
    	}
    	if (croissant) {
    		g.setColor(Color.red);
    		g.drawLine(148,107,266,107);
    		g.drawLine(148,107,151,105);
    		g.drawLine(148,107,151,109);
    		g.drawLine(266,107,263,105);
    		g.drawLine(266,107,263,109);
        	g.drawString("4d" , 200, 105);
    		g.setColor(Color.white);
    		g.drawLine(146,107,117,107);
    		g.drawLine(146,107,143,105);   
    		g.drawLine(146,107,143,109);   
    		g.drawLine(117,107,120,105);   
    		g.drawLine(117,107,120,109);   
        	g.drawString("d" , 130, 105);
        }
    	g.setColor(Color.black);
    	g.drawString(Messages.get("rapport_masses") + " : 1/4" , 19, 228);
    	g.drawString(Messages.get("rapport_distances") + " : 1/4" , 171, 228);
    	g.drawImage(bal1, 10 , 135, this);
		g.drawImage(bal4, 170 , 135, this);
		g.setColor(Color.white);
  		g.fillOval(-(int)(x/4)+137,60-(int)(y/4), 20,20);
  		g.fillOval(15,182, 13,13);
  		g.fillOval(175,186, 13,13);
  		g.setColor(Color.red);
  		g.fillOval((int)x+139,64+(int)y, 13,13);
  		g.fillOval(109,180, 7,7);
  		g.fillOval(117,180, 7,7);
  		g.fillOval(109,188, 7,7);
  		g.fillOval(117,188, 7,7);  		
  		g.fillOval(274,184, 7,7);    	
    }
    // rapport 1 sur 1000    
    if (select1000.getState()) {
		g.setColor(grisClair);
    	g.drawOval(27,47,240,47);  
    	g.setColor(Color.lightGray);
    	g.drawString(Messages.get("echelle") , 4, 12);
    	g.drawString(Messages.get("centre_de_gravite") , 105, 127);
    	g.drawString(Messages.get("jupiter") , -(int)x+131,55-(int)y);
    	for (int i = 69; i<112; i=i+6) {
    		g.drawLine(147,i,147,i+4);
    	}    	
    	g.setColor(Color.black);
    	g.drawImage(bal1, 10 , 135, this);
		g.drawImage(bal1000, 170 , 135, this);
		g.drawImage(soleil, 14,181, 15,15, this);
		g.drawImage(soleil, 176,191, 15,15, this);
    	g.drawString(Messages.get("rapport_masses") + " : 1/1000" , 10, 228);
    	g.drawString(Messages.get("rapport_distances") + " : 1/1000" , 171, 228);
		g.drawString(Messages.get("1000x") , 102, 207);
		g.drawImage(jupiter, 111,183, 12,12, this);
		g.drawImage(jupiter, 271,172, 12,12, this);
		if (croissant) {
	  		g.drawImage(soleil, (int)(x/12)+117 , 40+(int)(y/8), 60,60, this);
		  	g.setColor(grisClair);
		  	g.drawArc(27,47,240,47,255,30);	  
	  		g.drawImage(jupiter, -(int)x+137,60-(int)y, 20,20, this);
	  	}
	  	else {
	  		g.drawImage(jupiter, -(int)x+137,60-(int)y, 20,20, this);  		
	  		g.drawImage(soleil, (int)(x/12)+117 , 40+(int)(y/8), 60,60, this);
		  	g.setColor(grisClair);
		  	g.drawArc(27,47,240,47,255,30);
	  	}
    	g.setColor(Color.lightGray);
    	g.drawLine(147,69,147,73);
    	g.drawLine(145,71,149,71);
    }
    // Maj
    graphC.updateImage(img);
}


public void destroy()
  {  
  	g.finalize();
  	g.dispose();
  	jupiter.flush();
  	soleil.flush();
  	bal1.flush();
  	bal4.flush();
  	bal1000.flush();
}

}

